## snappy 1.1.6

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
PROJECT(Snappy VERSION 1.1.6 LANGUAGES C CXX)

SET(CMAKE_INCLUDE_CURRENT_DIR ON)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(TestBigEndian)
INCLUDE(CMakePackageConfigHelpers)

TEST_BIG_ENDIAN(WORDS_BIG_ENDIAN)
IF (WORDS_BIG_ENDIAN)
    MESSAGE(STATUS "Building on big endian system")
    ADD_DEFINITIONS(-DWORDS_BIGENDIAN=1)
ENDIF (WORDS_BIG_ENDIAN)

CHECK_INCLUDE_FILES("byteswap.h" HAVE_BYTESWAP_H)
CHECK_INCLUDE_FILES("dlfcn.h" HAVE_DLFCN_H)
CHECK_INCLUDE_FILES("inttypes.h" HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES("memory.h" HAVE_MEMORY_H)
CHECK_INCLUDE_FILES("stddef.h" HAVE_STDDEF_H)
CHECK_INCLUDE_FILES("stdint.h" HAVE_STDINT_H)
CHECK_INCLUDE_FILES("stdlib.h" HAVE_STDLIB_H)
CHECK_INCLUDE_FILES("strings.h" HAVE_STRINGS_H)
CHECK_INCLUDE_FILES("string.h" HAVE_STRING_H)
CHECK_INCLUDE_FILES("sys/byteswap.h" HAVE_SYS_BYTESWAP_H)
CHECK_INCLUDE_FILES("sys/endian.h" HAVE_SYS_ENDIAN_H)
CHECK_INCLUDE_FILES("sys/mman.h" HAVE_SYS_MMAN_H)
CHECK_INCLUDE_FILES("sys/resource.h" HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILES("sys/stat.h" HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES("sys/time.h" HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES("sys/uio.h" HAVE_SYS_UIO_H)
CHECK_INCLUDE_FILES("unistd.h" HAVE_UNISTD_H)
CHECK_INCLUDE_FILES("windows.h" HAVE_WINDOWS_H)

IF (NOT HAVE_SYS_UIO_H)
    SET(HAVE_SYS_UIO_H 0)
ENDIF (NOT HAVE_SYS_UIO_H)

IF (NOT HAVE_STDINT_H)
    SET(HAVE_STDINT_H 0)
ENDIF (NOT HAVE_STDINT_H)

IF (NOT HAVE_STDDEF_H)
    SET(HAVE_STDDEF_H 0)
ENDIF (NOT HAVE_STDDEF_H)

CHECK_LIBRARY_EXISTS(z zlibVersion "" HAVE_LIBZ)
CHECK_LIBRARY_EXISTS(lzo2 lzo1x_1_15_compress "" HAVE_LIBLZO2)

CHECK_CXX_SOURCE_COMPILES("int main(void) { return __builtin_expect(0, 1); }"
        HAVE_BUILTIN_EXPECT)

CHECK_CXX_SOURCE_COMPILES("int main(void) { return __builtin_ctzll(0); }"
        HAVE_BUILTIN_CTZ)

FIND_PACKAGE(GTest QUIET)
IF(GTEST_FOUND)
    SET(HAVE_GTEST 1)
ENDIF()

FIND_PACKAGE(Gflags QUIET)
IF(GFLAGS_FOUND)
    SET(HAVE_GFLAGS 1)
ENDIF()

CONFIGURE_FILE(${Snappy_SOURCE_DIR}/cmake/config.h.in config.h)

# Configure snappy-stubs-public.h.in
SET(ac_cv_have_stdint_h ${HAVE_STDINT_H})
SET(ac_cv_have_stddef_h ${HAVE_STDDEF_H})
SET(ac_cv_have_sys_uio_h ${HAVE_SYS_UIO_H})
CONFIGURE_FILE(${Snappy_SOURCE_DIR}/snappy-stubs-public.h.in
               snappy-stubs-public.h)

IF (WIN32)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ENDIF (WIN32)

# Define the main library.
ADD_LIBRARY(snappy SHARED
        snappy-c.cc
        snappy-c.h
        snappy-sinksource.cc
        snappy-sinksource.h
        snappy-stubs-internal.cc
        snappy-stubs-public.h
        snappy.cc
        snappy.h)

TARGET_COMPILE_DEFINITIONS(snappy PRIVATE -DHAVE_CONFIG_H)

SET_TARGET_PROPERTIES(snappy PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)

INSTALL(FILES snappy.h
        snappy-c.h
        snappy-sinksource.h
        ${Snappy_BINARY_DIR}/snappy-stubs-public.h
        DESTINATION include)

INSTALL(TARGETS snappy
        EXPORT SnappyTargets
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib)
INSTALL(EXPORT SnappyTargets NAMESPACE Snappy:: DESTINATION lib/cmake/Snappy)

SET_TARGET_PROPERTIES(snappy PROPERTIES VERSION ${PROJECT_VERSION}
                      SOVERSION ${PROJECT_VERSION_MAJOR})

SET(INCLUDE_INSTALL_DIR include)
SET(LIBRARY_INSTALL_DIR lib)
SET(BINARY_INSTALL_DIR bin)

CONFIGURE_PACKAGE_CONFIG_FILE(cmake/SnappyConfig.cmake.in
        ${Snappy_BINARY_DIR}/SnappyConfig.cmake
        INSTALL_DESTINATION lib/Snappy/cmake
        PATH_VARS INCLUDE_INSTALL_DIR LIBRARY_INSTALL_DIR BINARY_INSTALL_DIR
        )

WRITE_BASIC_PACKAGE_VERSION_FILE(${Snappy_BINARY_DIR}/SnappyConfigVersion.cmake
        COMPATIBILITY SameMajorVersion)
INSTALL(FILES ${Snappy_BINARY_DIR}/SnappyConfig.cmake
        ${Snappy_BINARY_DIR}/SnappyConfigVersion.cmake
        DESTINATION lib/cmake)

ENABLE_TESTING()

IF (HAVE_LIBZ)
    LIST(APPEND COMPRESSION_LIBS z)
ENDIF (HAVE_LIBZ)

IF (HAVE_LIBLZO2)
    LIST(APPEND COMPRESSION_LIBS lzo2)
ENDIF (HAVE_LIBLZO2)

IF (HAVE_LIBLZF)
    LIST(APPEND COMPRESSION_LIBS lzf)
ENDIF (HAVE_LIBLZF)

IF (HAVE_LIBQUICKLZ)
    LIST(APPEND COMPRESSION_LIBS quicklz)
ENDIF (HAVE_LIBQUICKLZ)

ADD_EXECUTABLE(snappy-unittest snappy_unittest.cc snappy-test.cc)
TARGET_COMPILE_DEFINITIONS(snappy-unittest PRIVATE -DHAVE_CONFIG_H)
TARGET_LINK_LIBRARIES(snappy-unittest snappy ${COMPRESSION_LIBS}
                      ${GFLAGS_LIBRARIES})
TARGET_INCLUDE_DIRECTORIES(snappy-unittest BEFORE PRIVATE ${Snappy_SOURCE_DIR}
                           ${GTEST_INCLUDE_DIRS} ${GFLAGS_INCLUDE_DIRS})

ADD_TEST(NAME snappy-unittest
         WORKING_DIRECTORY ${Snappy_SOURCE_DIR}
         COMMAND ${Snappy_BINARY_DIR}/snappy-unittest)

## snappy 1.1.3

=== debian/changelog ===
snappy (1.1.3-2) unstable; urgency=medium

  * Change package name to libsnappy1v5 for rebuild with g++-5.0 with the
    C++11 ABI; conflict with libsnappy1. (Closes: #791289, #794993)
  * Switch Debian packaging to the 3.0 (quilt) format.

 -- Steinar H. Gunderson <sesse@debian.org>  Sun, 09 Aug 2015 12:07:46 +0200

snappy (1.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Update Homepage: field in debian/control to reflect that Snappy is now
    distributed through GitHub. 

 -- Steinar H. Gunderson <sesse@debian.org>  Tue, 14 Jul 2015 15:18:14 +0200

snappy (1.1.2-4) unstable; urgency=low

  * Make package multi-arch capable; patch from Mathieu Malaterre.
    (Closes: #775409)

 -- Steinar H. Gunderson <sesse@debian.org>  Thu, 15 Jan 2015 23:12:50 +0100

snappy (1.1.2-3) unstable; urgency=medium

  * Add missing build-dependency on pkg-config, which is needed when we
    run autoreconf as part of the build; fixes FTBFS. (Closes: #756798)

 -- Steinar H. Gunderson <sesse@debian.org>  Sat, 02 Aug 2014 14:04:34 +0300

snappy (1.1.2-2) unstable; urgency=medium

  * Use dh-autoreconf instead of managing config.sub and config.guess
    ourselves; fixes FTBFS on ppc64el. Patch from Fernando Seiti Furusato.
    (Closes: #755933) 

 -- Steinar H. Gunderson <sesse@debian.org>  Thu, 24 Jul 2014 21:33:36 +0200

snappy (1.1.2-1) unstable; urgency=high

  * New upstream release.
    * Removes some test data that have unclear licensing, and which thus may
      violate the DFSG.
    * urgency=high due to the previous point.
  * Update to Standards-Version 3.9.5 (no changes needed).

 -- Steinar H. Gunderson <sesse@debian.org>  Wed, 09 Apr 2014 23:29:53 +0200

snappy (1.1.0-1) unstable; urgency=low

  * New upstream release.
    * Fixes divide by zero in unit test when run on platforms with
      very imprecise gettimeofday(). (Closes: #699419)
  * Do not run make check at build time if DEB_BUILD_OPTIONS contains
    nocheck.

 -- Steinar H. Gunderson <sesse@debian.org>  Sun, 10 Mar 2013 17:03:33 +0900

snappy (1.0.5-2) unstable; urgency=low

  * Disable unaligned accesses on ARMv4, not just ARMv5 and ARMv6.
    Fixes unit test segfaults and subsequent FTBFS on armel.
    (Closes: #679964) 

 -- Steinar H. Gunderson <sesse@debian.org>  Mon, 02 Jul 2012 19:30:10 +0200

snappy (1.0.5-1) unstable; urgency=low

  * New upstream release.
  * Use standard build flags from dpkg-buildflags, to get hardening etc.
    (also, at some point our previous setup started to give no optimization,
    which is not very good).
    * Build-Depend on dpkg-dev >= 1.61.1~.
  * Add dummy build-indep and build-arch targets (both just depend on build).
  * Upgrade to Standards-Version 3.9.3 (no changes needed).
  * Minor tweak to debian/copyright to make lintian happy.

 -- Steinar H. Gunderson <sesse@debian.org>  Thu, 29 Mar 2012 14:12:12 +0000

snappy (1.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Steinar H. Gunderson <sesse@debian.org>  Thu, 15 Sep 2011 21:39:31 +0200

snappy (1.0.3-1) unstable; urgency=low

  * New upstream release.
  * Updated Standards-Version to 3.9.2. (No changes needed.)

 -- Steinar H. Gunderson <sesse@debian.org>  Fri, 03 Jun 2011 01:08:08 +0200

snappy (1.0.2-1) unstable; urgency=low

  * New upstream release.
    * Update debian/copyright with new license (upstream changed from
      the Apache2 license to a BSD-style license).

 -- Steinar H. Gunderson <sesse@debian.org>  Fri, 29 Apr 2011 00:13:12 +0200

snappy (1.0.1-1) unstable; urgency=low

  * Initial release.

 -- Steinar H. Gunderson <sesse@debian.org>  Fri, 25 Mar 2011 01:44:25 +0100

=== debian/control ===
Source: snappy
Priority: extra
Maintainer: Steinar H. Gunderson <sesse@debian.org>
Build-Depends: debhelper (>= 8.1.3), dh-autoreconf, pkg-config, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.5
Section: libs
Homepage: https://github.com/google/snappy/

Package: libsnappy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsnappy1v5 (= ${binary:Version}), ${misc:Depends}
Description: fast compression/decompression library (development files)
 Snappy is a compression/decompression library. It does not aim for
 maximum compression, or compatibility with any other compression  
 library; instead, it aims for very high speeds and reasonable   
 compression.
 .
 For instance, compared to the fastest mode of zlib, Snappy
 is an order of magnitude faster for most inputs, but the resulting     
 compressed files are anywhere from 20% to 100% bigger. On a single core
 of a Core i7 processor in 64-bit mode, Snappy compresses at about 250  
 MB/sec or more and decompresses at about 500 MB/sec or more.
 .
 This package contains the development files required to build programs
 against Snappy.

Package: libsnappy1v5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsnappy1
Description: fast compression/decompression library
 Snappy is a compression/decompression library. It does not aim for
 maximum compression, or compatibility with any other compression  
 library; instead, it aims for very high speeds and reasonable   
 compression.
 .
 For instance, compared to the fastest mode of zlib, Snappy
 is an order of magnitude faster for most inputs, but the resulting     
 compressed files are anywhere from 20% to 100% bigger. On a single core
 of a Core i7 processor in 64-bit mode, Snappy compresses at about 250  
 MB/sec or more and decompresses at about 500 MB/sec or more.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Use standard biuld flags, but with assertions disabled (for performance).
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CXXFLAGS += -DNDEBUG

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

build-arch: build
build-indep: build
build: 
	dh_testdir
	dh_prep
	dh_autoreconf
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
	$(MAKE)
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	$(MAKE) check
endif

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_autoreconf_clean
	dh_clean 

binary: binary-arch
binary-indep:
binary-arch:
	dh_testdir
	dh_testroot
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	dh_install
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

.PHONY: build clean binary binary-indep binary-arch

## snappy 1.1.4

=== debian/changelog ===
snappy (1.1.4-1) unstable; urgency=medium

  * New upstream release.

 -- Steinar H. Gunderson <sesse@debian.org>  Fri, 27 Jan 2017 22:02:08 +0100

snappy (1.1.3-3) unstable; urgency=low

  * Build a convenience library libsnappy-shared.a, which is suitable for
    linking into a shared library. (Closes: #748627)
  * Change the download URL in debian/copyright to point to GitHub instead of
    Google Code, since upstream moved.
  * Update Standards-Version to 3.9.7 (no changes needed).

 -- Steinar H. Gunderson <sesse@debian.org>  Sat, 19 Mar 2016 14:38:04 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: extra
 Maintainer: Steinar H. Gunderson <sesse@debian.org>
 Build-Depends: debhelper (>= 8.1.3), dh-autoreconf, pkg-config, dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.7
 Section: libs
 Homepage: https://github.com/google/snappy/

## snappy 1.1.6

=== debian/changelog ===
snappy (1.1.6-4) unstable; urgency=medium

  * Correct libsnappy-shared.a symlink target (closes: #872226).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 20 Aug 2017 15:42:23 +0000

snappy (1.1.6-3) unstable; urgency=medium

  [ Niclas Rosenvik ]
  * Readd pkgconfig support (closes: #871437).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 08 Aug 2017 11:06:59 +0000

snappy (1.1.6-2) unstable; urgency=medium

  * Patch to build static library (closes: #868605).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 22 Jul 2017 07:26:07 +0000

snappy (1.1.6-1) unstable; urgency=medium

  * New upstream release.
  * Switch to short debhelper rules format.
  * Switch to CMake build system.
  * Force CMake build until autoconf build still exists.
  * Specify CMAKE_BUILD_TYPE to RelWithDebInfo.
  * Patch CMake to multiarch library install.
  * Install CMake files.
  * Enable parallel building.
  * Update Standards-Version to 4.0.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 15 Jul 2017 07:57:57 +0000

snappy (1.1.4-3) unstable; urgency=medium

  [ Steve Langasek <steve.langasek@canonical.com> ]
  * Use pristine upstream git source that works on armhf (closes: #866188).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 28 Jun 2017 15:35:33 +0000

snappy (1.1.4-2) unstable; urgency=low

  * New maintainer (closes: #863946).
  * Update Standards-Version to 3.9.8 and debhelper level to 10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Jun 2017 06:32:45 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEVPKGDIR:=$(CURDIR)/debian/libsnappy-dev

override_dh_auto_configure:
	echo ${DEB_HOST_MULTIARCH}
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH}

override_dh_install:
	dh_install
	ln -s /usr/lib/${DEB_HOST_MULTIARCH}/libsnappy.a \
		$(DEVPKGDIR)/usr/lib/${DEB_HOST_MULTIARCH}/libsnappy-shared.a

%:
	dh $@ --parallel --buildsystem=cmake --builddir=build/

.PHONY: override_dh_auto_configure override_dh_install

## snappy 1.1.7

=== debian/changelog ===
snappy (1.1.7-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 Sep 2017 17:17:21 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: snappy
 Priority: extra
-Maintainer: Steinar H. Gunderson <sesse@debian.org>
-Build-Depends: debhelper (>= 8.1.3), dh-autoreconf, pkg-config, dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.7
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends: debhelper (>= 10), cmake, pkg-config
+Standards-Version: 4.0.0
 Section: libs
 Homepage: https://github.com/google/snappy/

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,8 @@
 DEVPKGDIR:=$(CURDIR)/debian/libsnappy-dev
 
 override_dh_auto_configure:
-	echo ${DEB_HOST_MULTIARCH}
 	dh_auto_configure -- \
-		-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH}
+		-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} -DBUILD_SHARED_LIBS=on
 
 override_dh_install:
 	dh_install

## snappy 1.1.8

=== CMakeLists.txt ===
# Copyright 2019 Google Inc. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.1)
project(Snappy VERSION 1.1.8 LANGUAGES C CXX)

# C++ standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_CXX_STANDARD)
  # This project requires C++11.
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif(NOT CMAKE_CXX_STANDARD)

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to make
# it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries(DLLs)." OFF)

option(SNAPPY_BUILD_TESTS "Build Snappy's own tests." ON)

option(SNAPPY_FUZZING_BUILD "Build Snappy for fuzzing." OFF)

option(SNAPPY_REQUIRE_AVX "Target processors with AVX support." OFF)

option(SNAPPY_REQUIRE_AVX2 "Target processors with AVX2 support." OFF)

option(SNAPPY_INSTALL "Install Snappy's header and library" ON)

include(TestBigEndian)
test_big_endian(SNAPPY_IS_BIG_ENDIAN)

include(CheckIncludeFile)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_include_file("sys/endian.h" HAVE_SYS_ENDIAN_H)
check_include_file("sys/mman.h" HAVE_SYS_MMAN_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("sys/time.h" HAVE_SYS_TIME_H)
check_include_file("sys/uio.h" HAVE_SYS_UIO_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("windows.h" HAVE_WINDOWS_H)

include(CheckLibraryExists)
check_library_exists(z zlibVersion "" HAVE_LIBZ)
check_library_exists(lzo2 lzo1x_1_15_compress "" HAVE_LIBLZO2)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("/arch:AVX" HAVE_VISUAL_STUDIO_ARCH_AVX)
CHECK_CXX_COMPILER_FLAG("/arch:AVX2" HAVE_VISUAL_STUDIO_ARCH_AVX2)
CHECK_CXX_COMPILER_FLAG("-mavx" HAVE_CLANG_MAVX)
CHECK_CXX_COMPILER_FLAG("-mbmi2" HAVE_CLANG_MBMI2)
if(SNAPPY_REQUIRE_AVX2)
  if(HAVE_VISUAL_STUDIO_ARCH_AVX2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2")
  endif(HAVE_VISUAL_STUDIO_ARCH_AVX2)
  if(HAVE_CLANG_MAVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx")
  endif(HAVE_CLANG_MAVX)
  if(HAVE_CLANG_MBMI2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mbmi2")
  endif(HAVE_CLANG_MBMI2)
elseif (SNAPPY_REQUIRE_AVX)
  if(HAVE_VISUAL_STUDIO_ARCH_AVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX")
  endif(HAVE_VISUAL_STUDIO_ARCH_AVX)
  if(HAVE_CLANG_MAVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx")
  endif(HAVE_CLANG_MAVX)
endif(SNAPPY_REQUIRE_AVX2)

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
int main() {
  return __builtin_expect(0, 1);
}" HAVE_BUILTIN_EXPECT)

check_cxx_source_compiles("
int main() {
  return __builtin_ctzll(0);
}" HAVE_BUILTIN_CTZ)

check_cxx_source_compiles("
#include <tmmintrin.h>

int main() {
  const __m128i *src = 0;
  __m128i dest;
  const __m128i shuffle_mask = _mm_load_si128(src);
  const __m128i pattern = _mm_shuffle_epi8(_mm_loadl_epi64(src), shuffle_mask);
  _mm_storeu_si128(&dest, pattern);
  return 0;
}" SNAPPY_HAVE_SSSE3)

check_cxx_source_compiles("
#include <immintrin.h>
int main() {
  return _bzhi_u32(0, 1);
}" SNAPPY_HAVE_BMI2)

include(CheckSymbolExists)
check_symbol_exists("mmap" "sys/mman.h" HAVE_FUNC_MMAP)
check_symbol_exists("sysconf" "unistd.h" HAVE_FUNC_SYSCONF)

find_package(GTest QUIET)
if(GTEST_FOUND)
  set(HAVE_GTEST 1)
endif(GTEST_FOUND)

find_package(Gflags QUIET)
if(GFLAGS_FOUND)
  set(HAVE_GFLAGS 1)
endif(GFLAGS_FOUND)

configure_file(
  "cmake/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
)

# We don't want to define HAVE_ macros in public headers. Instead, we use
# CMake's variable substitution with 0/1 variables, which will be seen by the
# preprocessor as constants.
set(HAVE_SYS_UIO_H_01 ${HAVE_SYS_UIO_H})
if(NOT HAVE_SYS_UIO_H_01)
  set(HAVE_SYS_UIO_H_01 0)
endif(NOT HAVE_SYS_UIO_H_01)

if (SNAPPY_FUZZING_BUILD)
  if (NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    message(WARNING "Fuzzing builds are only supported with Clang")
  endif (NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")

  if(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=address")

  if(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=fuzzer-no-link")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer-no-link")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=fuzzer-no-link")
endif (SNAPPY_FUZZING_BUILD)

configure_file(
  "snappy-stubs-public.h.in"
  "${PROJECT_BINARY_DIR}/snappy-stubs-public.h")

add_library(snappy "")
target_sources(snappy
  PRIVATE
    "snappy-internal.h"
    "snappy-stubs-internal.h"
    "snappy-c.cc"
    "snappy-sinksource.cc"
    "snappy-stubs-internal.cc"
    "snappy.cc"
    "${PROJECT_BINARY_DIR}/config.h"

  # Only CMake 3.3+ supports PUBLIC sources in targets exported by "install".
  $<$<VERSION_GREATER:CMAKE_VERSION,3.2>:PUBLIC>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy-c.h>
    $<INSTALL_INTERFACE:include/snappy-c.h>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy-sinksource.h>
    $<INSTALL_INTERFACE:include/snappy-sinksource.h>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy.h>
    $<INSTALL_INTERFACE:include/snappy.h>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/snappy-stubs-public.h>
    $<INSTALL_INTERFACE:include/snappy-stubs-public.h>
)
target_include_directories(snappy
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)
set_target_properties(snappy
  PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(snappy PRIVATE -DHAVE_CONFIG_H)
if(BUILD_SHARED_LIBS)
  set_target_properties(snappy PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif(BUILD_SHARED_LIBS)

if(SNAPPY_BUILD_TESTS)
  enable_testing()

  add_executable(snappy_unittest "")
  target_sources(snappy_unittest
    PRIVATE
      "snappy_unittest.cc"
      "snappy-test.cc"
  )
  target_compile_definitions(snappy_unittest PRIVATE -DHAVE_CONFIG_H)
  target_link_libraries(snappy_unittest snappy ${GFLAGS_LIBRARIES})

  if(HAVE_LIBZ)
    target_link_libraries(snappy_unittest z)
  endif(HAVE_LIBZ)
  if(HAVE_LIBLZO2)
    target_link_libraries(snappy_unittest lzo2)
  endif(HAVE_LIBLZO2)

  target_include_directories(snappy_unittest
    BEFORE PRIVATE
      "${PROJECT_SOURCE_DIR}"
      "${GTEST_INCLUDE_DIRS}"
      "${GFLAGS_INCLUDE_DIRS}"
  )

  add_test(
    NAME snappy_unittest
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
    COMMAND "${PROJECT_BINARY_DIR}/snappy_unittest")
endif(SNAPPY_BUILD_TESTS)

if(SNAPPY_FUZZING_BUILD)
  add_executable(snappy_compress_fuzzer "")
  target_sources(snappy_compress_fuzzer
    PRIVATE "snappy_compress_fuzzer.cc"
  )
  target_link_libraries(snappy_compress_fuzzer snappy)
  set_target_properties(snappy_compress_fuzzer
    PROPERTIES LINK_FLAGS "-fsanitize=fuzzer"
  )

  add_executable(snappy_uncompress_fuzzer "")
  target_sources(snappy_uncompress_fuzzer
    PRIVATE "snappy_uncompress_fuzzer.cc"
  )
  target_link_libraries(snappy_uncompress_fuzzer snappy)
  set_target_properties(snappy_uncompress_fuzzer
    PROPERTIES LINK_FLAGS "-fsanitize=fuzzer"
  )
endif(SNAPPY_FUZZING_BUILD)

# Must be included before CMAKE_INSTALL_INCLUDEDIR is used.
include(GNUInstallDirs)

if(SNAPPY_INSTALL)
  install(TARGETS snappy
    EXPORT SnappyTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
  install(
    FILES
      "snappy-c.h"
      "snappy-sinksource.h"
      "snappy.h"
      "${PROJECT_BINARY_DIR}/snappy-stubs-public.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  )

  include(CMakePackageConfigHelpers)
  configure_package_config_file(
    "cmake/${PROJECT_NAME}Config.cmake.in"
    "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
  write_basic_package_version_file(
    "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
  )
  install(
    EXPORT SnappyTargets
    NAMESPACE Snappy::
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
  install(
    FILES
      "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake"
      "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
endif(SNAPPY_INSTALL)

=== debian/changelog ===
snappy (1.1.8-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 27 Jan 2020 20:19:20 +0000

snappy (1.1.7-2) unstable; urgency=medium

  * Fix snappy_unittest FTBFS.
  * Add watch file.
  * Update debhelper level to 12:
    - don't specify parallel to debhelper.
  * Update homepage location.
  * Update Standards-Version to 4.4.1:
    - change package priority to optional.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 05 Dec 2019 19:18:14 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: snappy
-Priority: extra
+Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 10), cmake, pkg-config
-Standards-Version: 4.0.0
+Build-Depends: debhelper-compat (= 12), cmake, pkg-config
+Standards-Version: 4.5.0
 Section: libs
-Homepage: https://github.com/google/snappy/
+Homepage: https://google.github.io/snappy/
 
 Package: libsnappy-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,6 @@
 		$(DEVPKGDIR)/usr/lib/${DEB_HOST_MULTIARCH}/libsnappy-shared.a
 
 %:
-	dh $@ --parallel --buildsystem=cmake --builddir=build/
+	dh $@ --buildsystem=cmake --builddir=build/
 
 .PHONY: override_dh_auto_configure override_dh_install

## snappy 1.1.9

=== debian/changelog ===
snappy (1.1.9-3) unstable; urgency=medium

  * Add option to enable rtti, set default to current behavior.
  * Enable rtti support (closes: 1031394).
  * Update Standards-Version to 4.6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 16 Feb 2023 20:31:32 +0100

snappy (1.1.9-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 08 May 2022 20:26:22 +0200

snappy (1.1.9-1) experimental; urgency=medium

  * New upstream release.
  * Update watch file.
  * Update copyright file.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.6.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 04 Dec 2021 19:21:57 +0100

=== debian/control ===
Source: snappy
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, pkgconf,
 libgtest-dev, libgmock-dev, libbenchmark-dev
Standards-Version: 4.6.2
Section: libs
Homepage: https://google.github.io/snappy/

Package: libsnappy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsnappy1v5 (= ${binary:Version}), ${misc:Depends}
Description: fast compression/decompression library (development files)
 Snappy is a compression/decompression library. It does not aim for
 maximum compression, or compatibility with any other compression
 library; instead, it aims for very high speeds and reasonable
 compression.
 .
 For instance, compared to the fastest mode of zlib, Snappy
 is an order of magnitude faster for most inputs, but the resulting
 compressed files are anywhere from 20% to 100% bigger. On a single core
 of a Core i7 processor in 64-bit mode, Snappy compresses at about 250
 MB/sec or more and decompresses at about 500 MB/sec or more.
 .
 This package contains the development files required to build programs
 against Snappy.

Package: libsnappy1v5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsnappy1
Description: fast compression/decompression library
 Snappy is a compression/decompression library. It does not aim for
 maximum compression, or compatibility with any other compression
 library; instead, it aims for very high speeds and reasonable
 compression.
 .
 For instance, compared to the fastest mode of zlib, Snappy
 is an order of magnitude faster for most inputs, but the resulting
 compressed files are anywhere from 20% to 100% bigger. On a single core
 of a Core i7 processor in 64-bit mode, Snappy compresses at about 250
 MB/sec or more and decompresses at about 500 MB/sec or more.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,11 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} -DBUILD_SHARED_LIBS=on
+		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
+		-DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} -DBUILD_SHARED_LIBS=ON \
+		-DSNAPPY_ENABLE_RTTI=ON \
+		-DSNAPPY_USE_BUNDLED_GTEST=OFF \
+		-DSNAPPY_USE_BUNDLED_BENCHMARK_LIB=OFF
 
 override_dh_install:
 	dh_install

=== debian/watch ===
version=4
opts=uversionmangle=s/^(SNAPSHOT|RELEASE)\.//;s/(\d+)[_-](\d+)[_-](\d+)/\$1.\$2.\$3/;s/(\d+)[_-](\d+)/\$1.\$2/;s/(\d)[_\.\-\+]?((rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/i,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i \
https://github.com/google/snappy/tags \
(?:|.*/)v?(\d\S*)@ARCHIVE_EXT@

## snappy 1.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.1)
-project(Snappy VERSION 1.1.8 LANGUAGES C CXX)
+project(Snappy VERSION 1.1.10 LANGUAGES C CXX)
 
 # C++ standard can be overridden when this is used as a sub-project.
 if(NOT CMAKE_CXX_STANDARD)
@@ -37,12 +37,59 @@
   set(CMAKE_CXX_EXTENSIONS OFF)
 endif(NOT CMAKE_CXX_STANDARD)
 
+# https://github.com/izenecloud/cmake/blob/master/SetCompilerWarningAll.cmake
+if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
+  # Use the highest warning level for Visual Studio.
+  set(CMAKE_CXX_WARNING_LEVEL 4)
+  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
+    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+  else(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
+  endif(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
+
+  # Disable C++ exceptions.
+  string(REGEX REPLACE "/EH[a-z]+" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHs-c-")
+  add_definitions(-D_HAS_EXCEPTIONS=0)
+
+  # Disable RTTI.
+  string(REGEX REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-")
+else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
+  # Use -Wall for clang and gcc.
+  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
+  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")
+
+  # Use -Wextra for clang and gcc.
+  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
+  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")
+
+  # Use -Werror for clang only.
+  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    if(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
+      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
+    endif(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
+  endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+
+  # Disable C++ exceptions.
+  string(REGEX REPLACE "-fexceptions" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
+
+  # Disable RTTI.
+  string(REGEX REPLACE "-frtti" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
+endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
+
 # BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to make
 # it prominent in the GUI.
 option(BUILD_SHARED_LIBS "Build shared libraries(DLLs)." OFF)
 
 option(SNAPPY_BUILD_TESTS "Build Snappy's own tests." ON)
 
+option(SNAPPY_BUILD_BENCHMARKS "Build Snappy's benchmarks" ON)
+
 option(SNAPPY_FUZZING_BUILD "Build Snappy for fuzzing." OFF)
 
 option(SNAPPY_REQUIRE_AVX "Target processors with AVX support." OFF)
@@ -55,8 +102,6 @@
 test_big_endian(SNAPPY_IS_BIG_ENDIAN)
 
 include(CheckIncludeFile)
-check_include_file("byteswap.h" HAVE_BYTESWAP_H)
-check_include_file("sys/endian.h" HAVE_SYS_ENDIAN_H)
 check_include_file("sys/mman.h" HAVE_SYS_MMAN_H)
 check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
 check_include_file("sys/time.h" HAVE_SYS_TIME_H)
@@ -67,6 +112,7 @@
 include(CheckLibraryExists)
 check_library_exists(z zlibVersion "" HAVE_LIBZ)
 check_library_exists(lzo2 lzo1x_1_15_compress "" HAVE_LIBLZO2)
+check_library_exists(lz4 LZ4_compress_default "" HAVE_LIBLZ4)
 
 include(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("/arch:AVX" HAVE_VISUAL_STUDIO_ARCH_AVX)
@@ -92,6 +138,10 @@
   endif(HAVE_CLANG_MAVX)
 endif(SNAPPY_REQUIRE_AVX2)
 
+# Used by googletest.
+check_cxx_compiler_flag(-Wno-missing-field-initializers
+                        SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
+
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles("
 int main() {
@@ -102,6 +152,13 @@
 int main() {
   return __builtin_ctzll(0);
 }" HAVE_BUILTIN_CTZ)
+
+check_cxx_source_compiles("
+__attribute__((always_inline)) int zero() { return 0; }
+
+int main() {
+  return zero();
+}" HAVE_ATTRIBUTE_ALWAYS_INLINE)
 
 check_cxx_source_compiles("
 #include <tmmintrin.h>
@@ -118,22 +175,34 @@
 check_cxx_source_compiles("
 #include <immintrin.h>
 int main() {
+  return _mm_crc32_u32(0, 1);
+}" SNAPPY_HAVE_X86_CRC32)
+
+check_cxx_source_compiles("
+#include <arm_neon.h>
+#include <arm_acle.h>
+int main() {
+  return __crc32cw(0, 1);
+}" SNAPPY_HAVE_NEON_CRC32)
+
+check_cxx_source_compiles("
+#include <immintrin.h>
+int main() {
   return _bzhi_u32(0, 1);
 }" SNAPPY_HAVE_BMI2)
+
+check_cxx_source_compiles("
+#include <arm_neon.h>
+int main() {
+  uint8_t val = 3, dup[8];
+  uint8x16_t v = vld1q_dup_u8(&val);
+  vst1q_u8(dup, v);
+  return 0;
+}" SNAPPY_HAVE_NEON)
 
 include(CheckSymbolExists)
 check_symbol_exists("mmap" "sys/mman.h" HAVE_FUNC_MMAP)
 check_symbol_exists("sysconf" "unistd.h" HAVE_FUNC_SYSCONF)
-
-find_package(GTest QUIET)
-if(GTEST_FOUND)
-  set(HAVE_GTEST 1)
-endif(GTEST_FOUND)
-
-find_package(Gflags QUIET)
-if(GFLAGS_FOUND)
-  set(HAVE_GFLAGS 1)
-endif(GFLAGS_FOUND)
 
 configure_file(
   "cmake/config.h.in"
@@ -202,96 +271,83 @@
   set_target_properties(snappy PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
 endif(BUILD_SHARED_LIBS)
 
+if(SNAPPY_BUILD_TESTS OR SNAPPY_BUILD_BENCHMARKS)
+  add_library(snappy_test_support "")
+  target_sources(snappy_test_support
+    PRIVATE
+      "snappy-test.cc"
+      "snappy-test.h"
+      "snappy_test_data.cc"
+      "snappy_test_data.h"
+      "${PROJECT_BINARY_DIR}/config.h"
+  )
+
+  # Test files include snappy-test.h, HAVE_CONFIG_H must be defined.
+  target_compile_definitions(snappy_test_support PUBLIC -DHAVE_CONFIG_H)
+
+  target_link_libraries(snappy_test_support snappy)
+
+  if(HAVE_LIBZ)
+    target_link_libraries(snappy_test_support z)
+  endif(HAVE_LIBZ)
+  if(HAVE_LIBLZO2)
+    target_link_libraries(snappy_test_support lzo2)
+  endif(HAVE_LIBLZO2)
+  if(HAVE_LIBLZ4)
+    target_link_libraries(snappy_test_support lz4)
+  endif(HAVE_LIBLZ4)
+
+  target_include_directories(snappy_test_support
+    BEFORE PUBLIC
+      "${PROJECT_SOURCE_DIR}"
+  )
+endif(SNAPPY_BUILD_TESTS OR SNAPPY_BUILD_BENCHMARKS)
+
 if(SNAPPY_BUILD_TESTS)
   enable_testing()
+
+  # Prevent overriding the parent project's compiler/linker settings on Windows.
+  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
+  set(install_gtest OFF)
+  set(install_gmock OFF)
+  set(build_gmock ON)
+
+  # This project is tested using GoogleTest.
+  add_subdirectory("third_party/googletest")
+
+  # GoogleTest triggers a missing field initializers warning.
+  if(SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
+    set_property(TARGET gtest
+        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
+    set_property(TARGET gmock
+        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
+  endif(SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
 
   add_executable(snappy_unittest "")
   target_sources(snappy_unittest
     PRIVATE
       "snappy_unittest.cc"
-      "snappy-test.cc"
-  )
-  target_compile_definitions(snappy_unittest PRIVATE -DHAVE_CONFIG_H)
-  target_link_libraries(snappy_unittest snappy ${GFLAGS_LIBRARIES})
-
-  if(HAVE_LIBZ)
-    target_link_libraries(snappy_unittest z)
-  endif(HAVE_LIBZ)
-  if(HAVE_LIBLZO2)
-    target_link_libraries(snappy_unittest lzo2)
-  endif(HAVE_LIBLZO2)
-
-  target_include_directories(snappy_unittest
-    BEFORE PRIVATE
-      "${PROJECT_SOURCE_DIR}"
-      "${GTEST_INCLUDE_DIRS}"
-      "${GFLAGS_INCLUDE_DIRS}"
-  )
+  )
+  target_link_libraries(snappy_unittest snappy_test_support gmock_main gtest)
 
   add_test(
     NAME snappy_unittest
     WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
     COMMAND "${PROJECT_BINARY_DIR}/snappy_unittest")
+
+  add_executable(snappy_test_tool "")
+  target_sources(snappy_test_tool
+    PRIVATE
+      "snappy_test_tool.cc"
+  )
+  target_link_libraries(snappy_test_tool snappy_test_support)
 endif(SNAPPY_BUILD_TESTS)
 
-if(SNAPPY_FUZZING_BUILD)
-  add_executable(snappy_compress_fuzzer "")
-  target_sources(snappy_compress_fuzzer
-    PRIVATE "snappy_compress_fuzzer.cc"
-  )
-  target_link_libraries(snappy_compress_fuzzer snappy)
-  set_target_properties(snappy_compress_fuzzer
-    PROPERTIES LINK_FLAGS "-fsanitize=fuzzer"
-  )
-
-  add_executable(snappy_uncompress_fuzzer "")
-  target_sources(snappy_uncompress_fuzzer
-    PRIVATE "snappy_uncompress_fuzzer.cc"
-  )
-  target_link_libraries(snappy_uncompress_fuzzer snappy)
-  set_target_properties(snappy_uncompress_fuzzer
-    PROPERTIES LINK_FLAGS "-fsanitize=fuzzer"
-  )
-endif(SNAPPY_FUZZING_BUILD)
-
-# Must be included before CMAKE_INSTALL_INCLUDEDIR is used.
-include(GNUInstallDirs)
-
-if(SNAPPY_INSTALL)
-  install(TARGETS snappy
-    EXPORT SnappyTargets
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  )
-  install(
-    FILES
-      "snappy-c.h"
-      "snappy-sinksource.h"
-      "snappy.h"
-      "${PROJECT_BINARY_DIR}/snappy-stubs-public.h"
-    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-  )
-
-  include(CMakePackageConfigHelpers)
-  configure_package_config_file(
-    "cmake/${PROJECT_NAME}Config.cmake.in"
-    "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake"
-    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
-  )
-  write_basic_package_version_file(
-    "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake"
-    COMPATIBILITY SameMajorVersion
-  )
-  install(
-    EXPORT SnappyTargets
-    NAMESPACE Snappy::
-    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
-  )
-  install(
-    FILES
-      "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake"
-      "${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake"
-    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
-  )
-endif(SNAPPY_INSTALL)
+if(SNAPPY_BUILD_BENCHMARKS)
+  add_executable(snappy_benchmark "")
+  target_sources(snappy_benchmark
+    PRIVATE
+      "snappy_benchmark.cc"
+  )
+  target_link_libraries(snappy_benchmark snappy_test_support benchmark_main)
+

=== debian/changelog ===
snappy (1.1.10-ok2.1) nile; urgency=medium

  * No-change rebuild for irregularity packaging branch. 

 -- liwenjun <liwenjun@kylinos.cn>  Tue, 19 Nov 2024 10:49:36 +0800

snappy (1.1.10-ok2) nile; urgency=medium

  * Add -fPIC for libsnappy-shared.a(needs by apitrace).

 -- liwenjun <liwenjun@kylinos.cn>  Tue, 19 Nov 2024 10:34:34 +0800

snappy (1.1.10-ok1) nile; urgency=medium

  * Build for openKylin.

 -- zhouganqing <zhouganqing@kylinos.cn>  Mon, 30 Oct 2023 17:53:19 +0800

snappy (1.1.8-ok1) yangtze; urgency=medium

  * Build for openKylin.

 -- openKylinBot <openKylinBot@openkylin.com>  Mon, 25 Apr 2022 22:03:04 +0800

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: snappy
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: openKylin Developers <developers@lists.openkylin.top>
 Build-Depends: debhelper-compat (= 13), cmake, pkgconf,
  libgtest-dev, libgmock-dev, libbenchmark-dev
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://google.github.io/snappy/
+Vcs-Git: https://gitee.com/openkylin/snappy.git
+Vcs-Browser: https://gitee.com/openkylin/snappy
 
 Package: libsnappy-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,15 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+# apitrace needs libsnappy-shared.a recompile with -fPIC
+export CFLAGS += -fPIC
+export CXXFLAGS += -fPIC
+
 DEVPKGDIR:=$(CURDIR)/debian/libsnappy-dev
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DCMAKE_CXX_STANDARD=14 \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		-DCMAKE_INSTALL_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} -DBUILD_SHARED_LIBS=ON \
 		-DSNAPPY_ENABLE_RTTI=ON \

## snappy 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 cmake_minimum_required(VERSION 3.1)
-project(Snappy VERSION 1.1.10 LANGUAGES C CXX)
+project(Snappy VERSION 1.2.1 LANGUAGES C CXX)
 
 # C++ standard can be overridden when this is used as a sub-project.
 if(NOT CMAKE_CXX_STANDARD)
@@ -72,6 +72,11 @@
       set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
     endif(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
   endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+
+  # Disable sign comparison warnings. Matches upcoming Bazel setup.
+  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wno-sign-compare")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-sign-compare")
+  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wno-sign-compare")
 
   # Disable C++ exceptions.
   string(REGEX REPLACE "-fexceptions" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -141,6 +146,8 @@
 # Used by googletest.
 check_cxx_compiler_flag(-Wno-missing-field-initializers
                         SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
+check_cxx_compiler_flag(-Wno-implicit-int-float-conversion
+                        SNAPPY_HAVE_NO_IMPLICIT_INT_FLOAT_CONVERSION)
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles("
@@ -152,6 +159,12 @@
 int main() {
   return __builtin_ctzll(0);
 }" HAVE_BUILTIN_CTZ)
+
+check_cxx_source_compiles("
+int main() {
+  __builtin_prefetch(0, 0, 3);
+  return 0;
+}" HAVE_BUILTIN_PREFETCH)
 
 check_cxx_source_compiles("
 __attribute__((always_inline)) int zero() { return 0; }
@@ -323,31 +336,10 @@
         APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
   endif(SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
 
+  if(SNAPPY_HAVE_NO_IMPLICIT_INT_FLOAT_CONVERSION)
+    set_property(TARGET gtest
+        APPEND PROPERTY COMPILE_OPTIONS -Wno-implicit-int-float-conversion)
+  endif(SNAPPY_HAVE_NO_IMPLICIT_INT_FLOAT_CONVERSION)
+
   add_executable(snappy_unittest "")
   target_sources(snappy_unittest
-    PRIVATE
-      "snappy_unittest.cc"
-  )
-  target_link_libraries(snappy_unittest snappy_test_support gmock_main gtest)
-
-  add_test(
-    NAME snappy_unittest
-    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
-    COMMAND "${PROJECT_BINARY_DIR}/snappy_unittest")
-
-  add_executable(snappy_test_tool "")
-  target_sources(snappy_test_tool
-    PRIVATE
-      "snappy_test_tool.cc"
-  )
-  target_link_libraries(snappy_test_tool snappy_test_support)
-endif(SNAPPY_BUILD_TESTS)
-
-if(SNAPPY_BUILD_BENCHMARKS)
-  add_executable(snappy_benchmark "")
-  target_sources(snappy_benchmark
-    PRIVATE
-      "snappy_benchmark.cc"
-  )
-  target_link_libraries(snappy_benchmark snappy_test_support benchmark_main)
-

=== debian/changelog ===
snappy (1.2.1-1) unstable; urgency=medium

  * New upstream release:
    - restores full ABI and API compatibility (closes: #1070785).
  * Use no for Rules-Requires-Root.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 22 May 2024 17:18:35 +0200

snappy (1.2.0-2) unstable; urgency=medium

  * Backport upstream fix to update library version number to 1.2.0 .
  * Patch to preserve API as of version 1.1.0 of the library
    (closes: #1070217).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 02 May 2024 18:36:25 +0200

snappy (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 01 May 2024 17:24:01 +0200

snappy (1.1.10-1) unstable; urgency=medium

  * New upstream release.
  * Configure with C++14 standard (closes: #1041028).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 17 Jul 2023 21:07:55 +0200
